<?php

require("config.php");
connect_db();

// Checks that the user's input variables exist in the database
function check_code_user($code, $userid) {
    $query  = sprintf("SELECT COUNT(user_id) FROM users WHERE code = '$code' AND user_id = '$userid'", mysql_real_escape_string($code), mysql_real_escape_string($userid));
	$result = @mysql_query($query) or die(mysql_error());
    $row = mysql_fetch_array($result);
    if ($row['COUNT(user_id)'] != 1) {
        return false;
    }
    else {
        return true;
    }
}

// Checks if a user already has given a vote
function has_voted($code, $userid) {
    $query  = sprintf("SELECT has_voted FROM users WHERE code = '$code' AND user_id = '$userid'", mysql_real_escape_string($code), mysql_real_escape_string($userid));
	$result = @mysql_query($query) or die(mysql_error());
    $row = mysql_fetch_array($result);
    if ($row['has_voted'] == 1) {
        return true;
    }
    else {
        return false;
    }
}

// Storing of result in DB
function store_result($code, $share1, $share2, $share3) {
	$save = @mysql_query(sprintf("
	INSERT INTO result (code, share1, share2, share3) 
	VALUES ('$code', '$share1', '$share2', '$share3')",
	mysql_real_escape_string($code),
	mysql_real_escape_string($share1),
	mysql_real_escape_string($share2),
	mysql_real_escape_string($share3))) or die(mysql_error());
	print "Answer stored in database... you will receive an e-mail when the results are ready!";
}

// Update the user table after a participant has voted
function update_user($code, $userid) {
	$save = @mysql_query(sprintf("
	UPDATE users SET has_voted = 1 WHERE code = '$code' AND user_id = '$userid'",
	mysql_real_escape_string($code),
	mysql_real_escape_string($userid))) or die(mysql_error());
}

// Fetches the number of participants in a poll
function get_number_of_participants($code) {
    $query  = sprintf("SELECT participants FROM poll WHERE code = '$code'", mysql_real_escape_string($code));
    $result = @mysql_query($query) or die(mysql_error());
    while ($row = mysql_fetch_array($result)) {
        $number_of_participants = $row['participants'];
    }
    return $number_of_participants;
}

// Checks if all participants have answered, if so, initiate an XML-RPC request to the computation servers
function check_answers($code) {
    $number_of_participants = get_number_of_participants($code);
    $query  = sprintf("SELECT COUNT(code) FROM result WHERE code = '$code'", mysql_real_escape_string($code));
    $result = @mysql_query($query) or die(mysql_error());
    // Print out result
    while ($row = mysql_fetch_array($result)) {
        //print "<p>There are " . $row['COUNT(code)'] . " answer(s) in the database.</p>";
        if ($row['COUNT(code)'] >= $number_of_participants) {
            initiate_xmlrpc_requests($code);
        }
    }
    // Disconnect the DB connection as the web server at this point has finished its tasks
    disconnect_db();
}

// Three different PHP files are executed, each destined for one of the computation servers
function initiate_xmlrpc_requests($code) {
    $urls = array(
       "http://folk.ntnu.no/havardv/smpc/xmlrpc-1.php?code=$code",
       "http://folk.ntnu.no/havardv/smpc/xmlrpc-2.php?code=$code",
       "http://folk.ntnu.no/havardv/smpc/xmlrpc-3.php?code=$code"
    );

    $mh = curl_multi_init();

    foreach ($urls as $i => $url) {
        $conn[$i] = curl_init($url);
        curl_setopt($conn[$i], CURLOPT_RETURNTRANSFER, 1);//return data as string 
        curl_setopt($conn[$i], CURLOPT_FOLLOWLOCATION, 1);//follow redirects
        curl_setopt($conn[$i], CURLOPT_MAXREDIRS, 2);//maximum redirects
        curl_setopt($conn[$i], CURLOPT_CONNECTTIMEOUT, 10);//timeout, use 0 to wait indefinitely
        curl_multi_add_handle($mh, $conn[$i]);
    }

    do {$n = curl_multi_exec($mh, $active);} while ($active);

    foreach ($urls as $i => $url) {
        $res[$i] = curl_multi_getcontent($conn[$i]);
        curl_multi_remove_handle($mh, $conn[$i]);
        curl_close($conn[$i]);
    }
    curl_multi_close($mh);

    //print_r($res);
}

// Normal display of poll i.e. Java applet
function show_poll($code, $userid) {
	$query  = sprintf("SELECT title, description, options FROM poll WHERE code = '$code'", mysql_real_escape_string($code));
	$result = @mysql_query($query) or die(mysql_error());
	$num = mysql_num_rows($result);
	if($num > 0) {
		$data = mysql_fetch_assoc($result);
		$title = $data["title"];
		$description = $data["description"];
		$options = explode(";",$data["options"]);
		$number_of_options = count($options) - 1;
		print "
        <h4>Java Applet:</h4>
        <applet code='Vote.class' width='400' height='450'>
            <param name='title' value='$title' />
            <param name='description' value='$description' />
            <param name='number_of_options' value='$number_of_options' />
            <param name='code_var' value='$code' />
            <param name='userid' value='$userid' />";
            for ($i=0; $i<$number_of_options; $i++) {
                $option_name = 'option' . $i;
                print "<param name='$option_name' value='$options[$i]' />";
            }
            print "</applet>";
	}
	else {
		print "<p>Error: problems showing the poll.</p>";
	}
}

?>