<?php

require("xmlrpc.inc");

// IP address and port number to the computation server
$host = '129.241.209.83';
$port = 8002;

if (isset($_GET['code'])) {
    $code = $_GET['code'];
}
    
// 1: INITIALIZE THE CLIENT
$xmlrpc_client = new xmlrpc_client('', $host, $port);
$xmlrpc_client->setDebug(0); // turn on debugging

// 2: CONSTRUCT THE REQUEST (AN XML-RPC MESSAGE)
$xmlrpc_msg = new xmlrpcmsg('initiate_computation', 
array(new xmlrpcval($code,'string')));

// 3: SEND THE REQUEST
$xmlrpc_resp = $xmlrpc_client->send($xmlrpc_msg);

// 4: WORKING WITH THE SERVER'S RESPONSE
if (!$xmlrpc_resp) {
    print "<p>Could not connect to HTTP server.</p>";
} 
elseif ($xmlrpc_resp->faultCode()) {
    print "<p>XML-RPC Fault #" . $xmlrpc_resp->faultCode() . ": " .
        $xmlrpc_resp->faultString();
} 
else {
    $struct = $xmlrpc_resp->value();
    $value = $struct->scalarval();
    print $value;
}

?>