<?php

session_start();
require "config.php";

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <title>Secure Multiparty Voting</title>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
	<link href="style.css" rel="stylesheet" />
</head>
<body>
	<div id="header">
		<img src="images/e-voting.gif" alt="" class="image" /><span class="header">Secure Multiparty Voting</span>
	</div>
    <div id="content">
    
<?php

connect_db();

$title = $_SESSION["title"];
$description = $_SESSION["description"];
$author = $_SESSION["author"];
$author_email = $_SESSION["author_email"];
$participants = $_SESSION["participants"];
$options = $_SESSION["options"];
$code = randomkeys(8);

// Build up a string containing all the participants' email addressses
$participants_email = "";
for ($i=1; $i<=$participants; $i++) {
    $participants_email = $participants_email . $_POST["email$i"] . ";";
}

save_poll($title, $description, $author, $author_email, $participants, $participants_email, $options, $code);

// Save each user and dispatch an e-mail at the same time
$email_array = explode(";", $participants_email);
for ($i=0; $i<$participants; $i++) {
    $user_id = randomkeys(8);
    
    save_user($code, $user_id);
    send_mail($email_array[$i], $title, $author, $author_email, $code, $user_id);
}

// Storing poll in DB
function save_poll($title, $description, $author, $author_email, $participants, $participants_email, $options, $code) {
    $save = @mysql_query(sprintf("
    INSERT INTO poll (title, description, author, author_email, participants, participants_email, options, code) 
    VALUES ('$title', '$description', '$author', '$author_email', '$participants', '$participants_email', '$options', '$code')",
    mysql_real_escape_string($title),
    mysql_real_escape_string($description),
    mysql_real_escape_string($author_email),
    mysql_real_escape_string($email),
    mysql_real_escape_string($participants),
    mysql_real_escape_string($participants_email),
    mysql_real_escape_string($options),
    mysql_real_escape_string($code))) or die(mysql_error());
    
    send_confirmation_mail($author_email, $title, $author);
}

// Storing user in DB
function save_user($code, $user_id) {
    $save = mysql_query(sprintf("
    INSERT INTO users (code, user_id) 
    VALUES ('$code', '$user_id')",
    mysql_real_escape_string($code),
    mysql_real_escape_string($user_id))) or die(mysql_error());
}

// New poll e-mail config
function send_mail($email, $title, $author, $author_email, $code, $user_id) {
    $to = $email;
    $subject = "New vote: $title";
    $message = $author . " has created a poll and wants you to deliver your answer at:
http://folk.ntnu.no/havardv/smpc/vote.php?code=" . $code . "&userid=" . $user_id;
    $headers = 'From: ' . $author_email . "\r\n" .
        'Reply-To: ' . $author_email . "\r\n" .
        'X-Mailer: PHP/' . phpversion();

    // Send mail
    if (mail($to, $subject, $message, $headers)) {
        print "<p>E-mail sent to $to</p>";
    }
    else {
        print "<p>Sending of e-mails failed...</p>";
    }
}

// Confirmation e-mail config
function send_confirmation_mail($author_email, $title, $author) {
    $to = $author_email;
    $subject = "Your vote: $title has been created.";
    $message = "Hello " . $author . "!\n" . "Your vote was successfully created and e-mails have been sent out to the participants. The results will be calculated and announced via e-mail when ready.";
    $headers = 'X-Mailer: PHP/' . phpversion();

    // Send mail
    if (mail($to, $subject, $message, $headers)) {
        print "<p>Poll created, check your e-mail inbox!</p><br />";
    }
    else {
        print "<p>Creation of poll failed...</p>";
    }
}

disconnect_db();

?>

    </div>
    <div id="bottom">
        <p>
            <a href="http://validator.w3.org/check?uri=referer">
                <img src="http://www.w3.org/Icons/valid-xhtml10-blue" alt="Valid XHTML 1.0 Transitional" height="31" width="88" />
            </a>
            <a href="http://jigsaw.w3.org/css-validator/check/referer">
                <img style="border:0;width:88px;height:31px" src="http://jigsaw.w3.org/css-validator/images/vcss-blue" alt="Valid CSS!" />
            </a>
        </p>
    </div>
</body>
</html>